"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Composition = void 0;

var _react = _interopRequireWildcard(require("react"));

var Three = _interopRequireWildcard(require("three"));

var _CSS3DRenderer = require("three/examples/jsm/renderers/CSS3DRenderer.js");

var _EffectComposer = require("./EffectComposer");

var _Loader = require("./Loader");

var _Decoration = require("./Decoration/Decoration");

var _Controller = require("./Controller");

var _Action = require("./Action");

var _Motion = require("./Motion");

var _tween = _interopRequireDefault(require("@tweenjs/tween.js"));

var _config = _interopRequireDefault(require("./config"));

require("../css/styles.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct.bind(); } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Composition = function (_Component) {
  _inherits(Composition, _Component);

  var _super = _createSuper(Composition);

  function Composition(_ref) {
    var _this;

    var camera = _ref.camera,
        glRenderer = _ref.glRenderer,
        cssRenderer = _ref.cssRenderer,
        postProcessing = _ref.postProcessing,
        _loaders = _ref.loaders,
        isLayerRendering = _ref.isLayerRendering;

    _classCallCheck(this, Composition);

    _this = _super.call(this);

    _defineProperty(_assertThisInitialized(_this), "setEventListeners", function () {
      window.addEventListener('resize', _this.resize);
      window.addEventListener('mousemove', function (_ref2) {
        var clientX = _ref2.clientX,
            clientY = _ref2.clientY;
        var _this$container = _this.container,
            offsetWidth = _this$container.offsetWidth,
            offsetHeight = _this$container.offsetHeight;

        var _this$container$getBo = _this.container.getBoundingClientRect(),
            top = _this$container$getBo.top,
            left = _this$container$getBo.left;

        _this.mouse.x = (clientX - left) / offsetWidth * 2 - 1;
        _this.mouse.y = -((clientY - top) / offsetHeight) * 2 + 1;

        if (_this.glRenderer) {
          if (_this.onMouseStop) clearTimeout(_this.onMouseStop);
          _this.onMouseStop = setTimeout(function () {
            _this.findIntersects();

            if (_this.intersects.length) {
              var visual = _this.intersects[0].object;
              if (visual.onMouseOver) visual.onMouseOver(visual);
            }
          }, 25);
        }
      });
      window.addEventListener('click', function () {
        if (_this.intersects.length) {
          var visual = _this.intersects[0].object;
          if (visual.onClick) visual.onClick(visual);
        }
      });
      window.addEventListener('touchmove', function (_ref3) {
        var changedTouches = _ref3.changedTouches;
        var _changedTouches$ = changedTouches[0],
            clientX = _changedTouches$.clientX,
            clientY = _changedTouches$.clientY;
        var _this$container2 = _this.container,
            offsetWidth = _this$container2.offsetWidth,
            offsetHeight = _this$container2.offsetHeight;

        var _this$container$getBo2 = _this.container.getBoundingClientRect(),
            top = _this$container$getBo2.top,
            left = _this$container$getBo2.left;

        _this.touch.x = (clientX - left) / offsetWidth * 2 - 1;
        _this.touch.y = -((clientY - top) / offsetHeight) * 2 + 1;
      });
    });

    _defineProperty(_assertThisInitialized(_this), "setInitialRoute", function () {
      var routes = _this.props.routes;
      var sceneId = null;

      if (_this.route) {
        var origin = "/".concat(_this.route.split('/')[1]);

        for (var r in routes) {
          if (routes[r] === origin || routes[r].path === origin) {
            sceneId = r;
          }
        }
      } else if (_this.activeScene) {
        sceneId = _this.activeScene.id;
      }

      if (sceneId) {
        var callback = routes && routes[sceneId].callback ? function () {
          return routes[sceneId].callback(_assertThisInitialized(_this), _this.route);
        } : false;

        _this.navigate(sceneId, {
          callback: callback
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "setPPEffects", function (effects) {
      var _this$container3 = _this.container,
          clientWidth = _this$container3.clientWidth,
          clientHeight = _this$container3.clientHeight;
      var pp = _this.props.postProcessing;
      if (!pp || !(effects !== null && effects !== void 0 && effects.length)) return false;
      _this.isPPEnabled = true;
      _this.composer.passes.length = 1;
      effects.forEach(function (eff, ei) {
        var ppEffect = null;

        if (eff.includes('Shader')) {
          ppEffect = new _EffectComposer.Passes.ShaderPass(pp[eff].src || _EffectComposer.Shaders[eff]);

          if (pp[eff].uniforms) {
            for (var u in pp[eff].uniforms) {
              ppEffect.uniforms[u].value = pp[eff].uniforms[u];
            }
          }
        } else {
          var Pass = pp[eff].src || _EffectComposer.Passes[eff];
          var params = pp[eff].params || [];
          ppEffect = _construct(Pass, _toConsumableArray(params));
        }

        ppEffect.renderToScreen = ei === effects.length - 1;

        _this.composer.addPass(ppEffect);
      });

      _this.composer.setSize(clientWidth, clientHeight);
    });

    _defineProperty(_assertThisInitialized(_this), "setLoaders", function (loaders) {
      _this.loadingManager = new Three.LoadingManager();
      _this.animationLoader = new Three.AnimationLoader(_this.loadingManager);
      _this.audioLoader = new Three.AudioLoader(_this.loadingManager);
      _this.textureLoader = new Three.TextureLoader(_this.loadingManager);
      _this.loaders = {};

      _this.loadingManager.onProgress = function (item, loaded, total) {
        return _this.setState({
          loaded: loaded,
          total: total
        });
      };

      _this.loadingManager.onLoad = function () {
        return _this.setState({
          loading: false
        });
      };

      if (loaders) {
        loaders.forEach(function (l) {
          if (_Loader.Loaders["".concat(l, "Loader")] && !_this.loaders["".concat(l, "Loader")]) {
            _this.loaders["".concat(l, "Loader")] = new _Loader.Loaders["".concat(l, "Loader")](_this.loadingManager);
          }
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "setVisualState", function (id, state) {
      return _this.find(id).setVisualState(state);
    });

    _defineProperty(_assertThisInitialized(_this), "setMotion", function (id, motion) {
      return _this.find(id).setMotion(motion);
    });

    _defineProperty(_assertThisInitialized(_this), "setTouchPosition", function (x, y) {
      return _this.touch.set(x, y);
    });

    _defineProperty(_assertThisInitialized(_this), "getAction", function (id) {
      return _this.actions[id];
    });

    _defineProperty(_assertThisInitialized(_this), "onUpdate", function (handler) {
      return _this.onUpdateHandlers.push(handler);
    });

    _defineProperty(_assertThisInitialized(_this), "clearUpdateHandlers", function () {
      return _this.onUpdateHandlers = [];
    });

    _defineProperty(_assertThisInitialized(_this), "update", function () {
      for (var k in _this.children) {
        _this.children[k].update();
      }

      if (_this.isPPEnabled) {
        if (_this.isLayerRendering) {
          for (var l in _this.layers) {
            _this.camera.layers.set(_this.layers[l]);

            _this.composer.render();
          }

          _this.glRenderer.clearDepth();

          _this.camera.layers.set(0);

          _this.glRenderer.render(_this.visual, _this.camera);
        } else {
          _this.composer.render();
        }
      } else if (_this.glRenderer) {
        _this.glRenderer.render(_this.visual, _this.camera);
      }

      if (_this.cssRenderer) {
        _this.cssRenderer.render(_this.visual, _this.camera);
      }

      _tween["default"].update();

      _this.onUpdateHandlers.forEach(function (handler) {
        return handler();
      });

      requestAnimationFrame(_this.update);
    });

    _defineProperty(_assertThisInitialized(_this), "navigate", function (id, params) {
      var routes = _this.props.routes;

      var scene = _this.find(id);

      if (scene) {
        var events = ['onMouseWheel', 'onMouseMove', 'onClick', 'onKeyUp', 'onTouchMove', 'onTouchStart'];

        for (var e = 0; e < events.length; e++) {
          window[events[e].toLowerCase()] = scene.props[events[e]] || null;
        }

        _this.activeScene = scene;
      }

      if (routes) {
        window.history.pushState({}, _this.activeScene.id, routes[id].path || routes[id]);
      }

      if (_this.activeScene.ppEffects) {
        _this.setPPEffects(_this.activeScene.ppEffects);
      }

      _this.actions["".concat(id, ":Navigate")].begin(_objectSpread(_objectSpread({
        duration: _this.activeScene.props.navigationDuration
      }, params), {}, {
        enforce: true
      }));
    });

    _defineProperty(_assertThisInitialized(_this), "resize", function () {
      var _this$container4 = _this.container,
          clientWidth = _this$container4.clientWidth,
          clientHeight = _this$container4.clientHeight;

      if (_this.glRenderer) {
        _this.glRenderer.setSize(clientWidth, clientHeight);
      }

      if (_this.cssRenderer) {
        _this.cssRenderer.setSize(clientWidth, clientHeight);
      }

      if (_this.isPPEnabled) {
        _this.composer.setSize(clientWidth, clientHeight);
      }

      _this.camera.aspect = clientWidth / clientHeight;

      _this.camera.updateProjectionMatrix();
    });

    _defineProperty(_assertThisInitialized(_this), "findIntersects", function () {
      _this.raycaster.setFromCamera(_this.mouse, _this.camera);

      if (_this.activeScene) {
        if (_this.activeScene.isGLEvents) {
          _this.intersects = _this.raycaster.intersectObjects(_this.activeScene.visual.children, true);
        }
      } else {
        _this.intersects = _this.raycaster.intersectObjects(_this.visual.children, true);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "connectActions", function (decoration, actions) {
      for (var a in actions) {
        if (!_this.actions[a]) _this.actions[a] = new _Action.Action();

        _this.actions[a].addDecoration(decoration, actions[a]);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "resetActions", function () {
      return _tween["default"].removeAll();
    });

    _defineProperty(_assertThisInitialized(_this), "execActionsSequence", function (actionIds, params) {
      _this.actions[actionIds[0]].begin(_this.buildActionsSequence(actionIds, 1, params));
    });

    _defineProperty(_assertThisInitialized(_this), "buildActionsSequence", function (actionIds, index, params) {
      var p = _objectSpread({}, params);

      if (actionIds[index]) {
        p.callback = function () {
          return _this.actions[actionIds[index]].begin(params);
        };
      }

      if (index < actionIds.length - 1) {
        params = _this.buildActionsSequence(actionIds, index + 1, params);
      }

      return p;
    });

    _defineProperty(_assertThisInitialized(_this), "enablePostProcessing", function (isEnabled) {
      return _this.isPPEnabled = isEnabled;
    });

    _defineProperty(_assertThisInitialized(_this), "enableLayerRendering", function (isEnabled) {
      return _this.isLayerRendering = isEnabled;
    });

    _defineProperty(_assertThisInitialized(_this), "find", function (id) {
      for (var k in _this.children) {
        var c = _this.children[k].find(id);

        if (c) return c;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "findAll", function (id) {
      var all = [];

      for (var k in _this.children) {
        _this.children[k].findAll(id, all);
      }

      return all;
    });

    _defineProperty(_assertThisInitialized(_this), "isMobilePlatform", function () {
      var platforms = [/Android/i, /BlackBerry/i, /IEMobile/i, /Opera Mini/i, /Windows Phone/i, /iPhone/i, /iPad/i, /iPod/i, /webOS/i];
      return platforms.some(function (p) {
        return navigator.userAgent.match(p);
      });
    });

    _defineProperty(_assertThisInitialized(_this), "isMobileScreen", function () {
      return _this.container.clientWidth <= _config["default"].MOBILE_SCREEN_WIDTH;
    });

    _defineProperty(_assertThisInitialized(_this), "isSceneActive", function (id) {
      return id === _this.activeScene.id;
    });

    _defineProperty(_assertThisInitialized(_this), "capitalize", function (v) {
      return v.charAt(0).toUpperCase() + v.slice(1);
    });

    _this.state = {
      loading: true,
      loaded: 0,
      total: 0
    };
    _this.children = {};
    _this.actions = {};
    _this.layers = {};
    _this.intersects = [];
    _this.onUpdateHandlers = [];
    _this.isPPEnabled = false;
    _this.isActionsEnabled = true;
    _this.isLayerRendering = isLayerRendering || false;
    _this.mouse = new Three.Vector2(-1, -1);
    _this.touch = new Three.Vector2(-1, -1);
    _this.visual = new Three.Scene();
    _this.camera = new Three["".concat(_this.capitalize(camera.type), "Camera")](camera.fov, 1, camera.near, camera.far);

    if (glRenderer) {
      _this.glRenderer = new Three.WebGLRenderer(glRenderer);

      _this.glRenderer.setPixelRatio(window.devicePixelRatio);

      _this.raycaster = new Three.Raycaster();
      _this.audioListener = new Three.AudioListener();

      _this.camera.add(_this.audioListener);

      _this.setLoaders(_loaders);

      if (glRenderer.autoClear !== undefined) {
        _this.glRenderer.autoClear = glRenderer.autoClear;
      }
    } else {
      _this.state.loading = false;
    }

    if (cssRenderer) {
      _this.cssRenderer = new _CSS3DRenderer.CSS3DRenderer();
    }

    if (postProcessing) {
      _this.composer = new _EffectComposer.EffectComposer(_this.glRenderer);

      _this.composer.addPass(new _EffectComposer.Passes.RenderPass(_this.visual, _this.camera));
    }

    if (window.location.pathname !== '/') {
      _this.route = window.location.pathname;
    }

    _Decoration.Decoration.prototype.manager = _assertThisInitialized(_this);
    _Controller.Controller.prototype.manager = _assertThisInitialized(_this);
    _Action.Action.prototype.manager = _assertThisInitialized(_this);
    _Motion.Motion.prototype.manager = _assertThisInitialized(_this);
    return _this;
  }

  _createClass(Composition, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      if (this.glRenderer) {
        this.glContainer.appendChild(this.glRenderer.domElement);
        setTimeout(function () {
          if (!_this2.state.total) {
            _this2.setState({
              loading: false
            });
          }
        }, 100);
      }

      if (this.cssRenderer) {
        this.cssContainer.appendChild(this.cssRenderer.domElement);
      }

      this.setEventListeners();
      this.setInitialRoute();
      this.update();
      this.resize();
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$state = this.state,
          loading = _this$state.loading,
          loaded = _this$state.loaded,
          total = _this$state.total;
      return _react["default"].createElement(_react.Fragment, null, _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this3.container = c;
        },
        className: 'rtc-container'
      }, _react["default"].createElement("div", {
        id: 'portal',
        className: 'rtc-renderer-container'
      }), _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this3.glContainer = c;
        },
        className: 'rtc-renderer-container'
      }), _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this3.cssContainer = c;
        },
        className: 'rtc-renderer-container'
      }), loading && _react["default"].createElement("div", {
        className: 'rtc-loader-container'
      }, _react["default"].createElement("div", {
        className: 'rtc-loader-container rtc-gradient'
      }, _toConsumableArray(Array(7)).map(function (h, hi) {
        return _react["default"].createElement("div", {
          key: hi,
          className: "rtc-hexagon rtc-".concat(hi === 0 ? 'center' : "side".concat(hi))
        }, _react["default"].createElement("div", {
          className: 'rtc-hp1'
        }), _react["default"].createElement("div", {
          className: 'rtc-hp1 rtc-hp2'
        }), _react["default"].createElement("div", {
          className: 'rtc-hp1 rtc-hp3'
        }));
      }), _react["default"].createElement("div", {
        className: 'rtc-text-loader'
      }, "Loading resources (", loaded, " of ", total, ")")))), this.props.children);
    }
  }]);

  return Composition;
}(_react.Component);

exports.Composition = Composition;